当前位置: 首页 > 工具软件 > Rabbits > 使用案例 >

HDU 4745 Two Rabbits——最长回文子串

隗昀
2023-12-01

Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai. 

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise. 

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise. 

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn't jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone. 

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time. 

Now they want to find out the maximum turns they can play if they follow the optimal strategy.

Input

The input contains at most 20 test cases. 
For each test cases, the first line contains a integer n denoting the number of stones. 
The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000) 
The input ends with n = 0.

Output

For each test case, print a integer denoting the maximum turns.

Sample Input

1
1
4
1 1 2 1
6
2 1 1 2 1 3
0

Sample Output

1
4
5

        
  

Hint

For the second case, the path of the Tom is 1, 2, 3, 4, and the path of Jerry is 1, 4, 3, 2.
For the third case, the path of Tom is 1,2,3,4,5 and the path of Jerry is 4,3,2,1,5.

题意:求最长回文串的长度之后再稍做处理就可以得到答案,叫这个题给坑了他在把环拆开扩展成链的做法的时候并不是所有情况都是真正的回文串。根据第二组样例来看最长的回文串应该是3然而答案是4,这就跟兔子的起跳有关 一种情况就是在区间长为n的区间中的最长回文串的两端开始跳,另一种就是抠出一个点来从区间长度为n-1的区间里的最长回文串开始跳,因为是循环的兔子就可以从抠出的那一个点开始(尽管加上这一个点那个最长的回文子串就不再是回文串)跳向那个最长的回文子串的两端然后情况就同第一种了。

另一种方式就是不破环以区间内某一个点为分界点求这分界点两边最长的回文串长度加起来就行

#include <stdio.h>
#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <string.h>
#include <vector>
#include <queue>
#include <stack>
typedef long long LL;
using namespace std;
const LL MOD=1e9+7;
int a[5009];
int dp[2009][2009];
int main()
{
    int n;
    while(cin>>n){
        if(!n)
            break;
        memset(dp,0,sizeof(dp));
        for(int i=0;i<n;i++)
        {
            cin>>a[i];
            a[i+n]=a[i];
        }
        for(int i=0;i<2*n;i++){
            dp[i][i]=1;
        }
        for(int i=2;i<=n;i++){
            for(int j=0;j+i-1<2*n;j++){
                int r=i+j-1;
                if(a[j]==a[r])
                    dp[j][r]=dp[j+1][r-1]+2;
                else
                    dp[j][r]=max(dp[j+1][r],dp[j][r-1]);
            }
        }
        int ans=0;
        for(int i=0;i<n;i++)
        {
            ans=max(ans,dp[i][i+n-1]);
            ans=max(ans,dp[i][i+n-2]+1);
        }
        
        cout<<ans<<endl;
    }


}

 

 类似资料: